.syntax	unified
.thumb
.text
.align 4

@ =============== S U B	R O U T	I N E =======================================

sub_0:					

var_18		= -0x18

		PUSH	{R3-R7,LR}
		MOVS	R0, #0
		MOVS	R6, R0
		MOVS	R0, #'1'
		STRB.W	R0, [SP,#0x18+var_18]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x18+var_18
		BL	transfer
		MOVS	R0, #'2'
		STRB.W	R0, [SP,#0x18+var_18]

loc_1C:					
		MOVS	R0, #0
		MOVS	R7, R0
		MOVS	R2, #0
		MOVS	R1, #5
		LDR.W	R0, =0x2003F800
		BL	transfer
		LDR.W	R0, =0x2003F800
		LDRB	R0, [R0]
		UXTB	R0, R0
		CMP	R0, #8
		BEQ	cmd_write_sector
		CMP	R0, #0x28
		BEQ	cmd_read
		CMP	R0, #0x38
		BEQ	cmd_erase
		CMP	R0, #0x39
		BEQ.W	cmd_get_special
		CMP	R0, #0x3A
		BEQ.W	cmd_program_vfy
		CMP	R0, #0x48
		BEQ	cmd_blank
		B	loc_1B6
@ ---------------------------------------------------------------------------

cmd_erase:				
		BL	do_erase
		MOVS	R6, R0
		B	loc_1C0
@ ---------------------------------------------------------------------------

cmd_write_sector:			
		LDR.W	R0, =0x2003F801
		LDRB	R0, [R0]
		UXTB	R0, R0
		MOVS	R4, R0
		LDR.W	R0, =0x2003F802
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#8
		LDR.W	R0, =0x2003F803
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#16
		LDR.W	R0, =0x2003F804
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#24
		MOVW	R1, #0x202
		MOVS	R0, R4
		BL	do_some_write
		MOVS	R6, R0
		B	loc_1C0
@ ---------------------------------------------------------------------------

cmd_read:				
		LDR.W	R0, =0x2003F801
		LDRB	R0, [R0]
		UXTB	R0, R0
		MOVS	R4, R0
		LDR.W	R0, =0x2003F802
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#8
		LDR.W	R0, =0x2003F803
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#16
		LDR.W	R0, =0x2003F804
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#24
		MOV.W	R1, #0x200
		MOVS	R0, R4
		BL	do_read
		MOVS	R6, R0
		B	loc_1C0
@ ---------------------------------------------------------------------------

cmd_blank:				
		LDR.W	R0, =0x2003F801
		LDRB	R0, [R0]
		UXTB	R0, R0
		MOVS	R4, R0
		LDR.W	R0, =0x2003F802
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#8
		LDR.W	R0, =0x2003F803
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#16
		LDR.W	R0, =0x2003F804
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#24
		MOVS	R2, #0
		MOVS	R1, #4
		LDR.W	R0, =0x2003F800
		BL	transfer
		LDR.W	R0, =0x2003F800
		LDRB	R0, [R0]
		UXTB	R0, R0
		MOVS	R5, R0
		LDR.W	R0, =0x2003F801
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R5, R5,	R0,LSL#8
		LDR.W	R0, =0x2003F802
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R5, R5,	R0,LSL#16
		LDR.W	R0, =0x2003F803
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R5, R5,	R0,LSL#24
		MOVS	R1, R5
		MOVS	R0, R4
		BL	vfy_blank
		MOVS	R6, R0
		B	loc_1C0
@ ---------------------------------------------------------------------------

cmd_get_special:			
		LDR.W	R0, =0x2003F801
		LDRB	R0, [R0]
		UXTB	R0, R0
		MOVS	R4, R0
		LDR.W	R0, =0x2003F802
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#8
		LDR.W	R0, =0x2003F803
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#16
		LDR.W	R0, =0x2003F804
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#24
		MOVS	R0, R4
		BL	read_out
		MOVS	R6, R0
		B	loc_1C0
@ ---------------------------------------------------------------------------

cmd_program_vfy:			
		LDR.W	R0, =0x2003F801
		LDRB	R0, [R0]
		UXTB	R0, R0
		MOVS	R4, R0
		LDR.W	R0, =0x2003F802
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#8
		LDR.W	R0, =0x2003F803
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#16
		LDR.W	R0, =0x2003F804
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#24
		MOVS	R0, R4
		BL	write_flash
		MOVS	R6, R0
		B	loc_1C0
@ ---------------------------------------------------------------------------

loc_1B6:				
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x18+var_18
		BL	transfer

loc_1C0:				
		UXTH	R6, R6
		CMP	R6, #0
		BEQ.W	loc_1C
		MOVS	R0, #1
		MOVS	R7, R0
		UXTB	R7, R7
		CMP	R7, #0
		BEQ	locret_1D4

loc_1D2:				
		B	loc_1D2
@ ---------------------------------------------------------------------------

locret_1D4:				
		POP	{R0,R4-R7,PC}
@ End of function sub_0

.pool

@ =============== S U B	R O U T	I N E =======================================


transfer:				
		PUSH.W	{R3-R9,LR}
		MOVS	R4, R0
		MOVS	R5, R1
		MOVS	R6, R2
		UXTH	R5, R5
		MOVS	R7, R5
		MOV	R9, R4

loc_1E6:				
		BL	sub_AA2
		MOVS	R0, #0
		MOV	R8, R0
		UXTB	R6, R6
		CMP	R6, #0
		BEQ	loc_204
		MOVS	R2, R7
		MOV	R1, R9
		LDR.W	R0, =0x2003E8D8
		BL	sub_C5E
		MOV	R8, R0
		B	loc_212
@ ---------------------------------------------------------------------------

loc_204:				
		MOVS	R2, R7
		MOV	R1, R9
		LDR.W	R0, =0x2003E8A0
		BL	sub_C12
		MOV	R8, R0

loc_212:				
		CMP	R8, R7
		BCS	loc_220
		ADDS.W	R9, R8,	R9
		SUBS.W	R7, R7,	R8
		B	loc_1E6
@ ---------------------------------------------------------------------------

loc_220:				
		BL	sub_AA2
		MOVS	R0, #0
		POP.W	{R1,R4-R9,PC}
@ End of function transfer


@ =============== S U B	R O U T	I N E =======================================


do_erase:				

var_10		= -0x10

		PUSH	{R4,LR}
		SUB	SP, SP,	#8
		MOVS	R0, #0
		MOVS	R4, R0
		MOVS	R0, #0x30
		STRB.W	R0, [SP,#0x10+var_10]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x10+var_10
		BL	transfer
		MOVS	R0, #1
		BL	set_mode_user_pgm
		MOVW	R0, #0xAA8
		BL	chip_erase_work
		MOVS	R4, R0
		MOVS	R0, #0
		BL	set_mode_user_pgm
		UXTH	R4, R4
		CMP	R4, #0
		BNE	loc_266
		MOVS	R0, #0x31
		STRB.W	R0, [SP,#0x10+var_10]
		B	loc_26C
@ ---------------------------------------------------------------------------

loc_266:	
		MOVS	R0, #0x34
		STRB.W	R0, [SP,#0x10+var_10]

loc_26C:
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x10+var_10
		BL	transfer
		MOVS	R0, R4
		UXTH	R0, R0
		POP	{R1,R2,R4,PC}
@ End of function do_erase


@ =============== S U B	R O U T	I N E =======================================


do_some_write:				

var_28		= -0x28
var_26		= -0x26

		PUSH.W	{R3-R11,LR}
		MOVS	R4, R0
		MOVS	R5, R1
		MOVS	R0, #0
		MOV	R10, R0
		MOVS	R0, #0x30
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R0, #0x31 @ '1'
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R2, #0
		MOVS	R1, R5
		UXTH	R1, R1
		LDR.W	R0, =0x2003F800
		BL	transfer
		UXTH	R5, R5
		MOVS	R1, R5
		LDR.W	R0, =0x2003F800
		BL	compute_crc
		STRH.W	R0, [SP,#0x28+var_26]
		LDRH.W	R0, [SP,#0x28+var_26]
		CMP	R0, #0
		BEQ	loc_2D6
		MOVS	R0, #0x35 @ '5'
		STRB.W	R0, [SP,#0x28+var_28]
		B	loc_2DC
@ ---------------------------------------------------------------------------

loc_2D6:				
		MOVS	R0, #0x30 @ '0'
		STRB.W	R0, [SP,#0x28+var_28]

loc_2DC:				
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R0, #1
		BL	set_mode_user_pgm
		CMP.W	R4, #0x10000000
		BCS	loc_388
		LDR.W	R0, =0x40000008
		MOVS	R1, #0
		STRB	R1, [R0]
		MOVS	R0, #0
		MOV	R11, R0
		MOV	R8, R4

loc_300:				
		UXTH.W	R11, R11
		CMP.W	R11, #0x200
		BCS	loc_338
		UXTH.W	R11, R11
		LDR.W	R0, =0x2003F800
		LDRH.W	R0, [R11,R0]
		MOV	R9, R0
		MOV	R1, R9
		UXTH	R1, R1
		MOV	R0, R8
		BL	write_sector
		MOV	R10, R0
		UXTH.W	R10, R10
		CMP.W	R10, #0
		BNE	loc_338
		ADDS.W	R11, R11, #2
		ADDS.W	R8, R8,	#2
		B	loc_300
@ ---------------------------------------------------------------------------

loc_338:				
					@ do_some_write+B0j
		MOVS	R0, #0
		BL	set_mode_user_pgm
		MOVS	R0, #0
		MOV	R11, R0
		MOV	R8, R4

loc_344:				
		UXTH.W	R11, R11
		CMP.W	R11, #0x200
		BCS	loc_404
		UXTH.W	R11, R11
		LDR.W	R0, =0x2003F800
		LDR.W	R0, [R11,R0]
		MOVS	R7, R0
		LDR.W	R0, [R8]
		MOVS	R6, R0
		CMP	R6, R7
		BEQ	loc_36C
		MOVS	R0, #1
		MOV	R10, R0
		B	loc_404
@ ---------------------------------------------------------------------------

loc_36C:				
		LDR.W	R0, =0x40000008
		LDRB	R0, [R0]
		UXTB	R0, R0
		LSLS	R0, R0,	#0x1D
		BPL	loc_37E
		MOVS	R0, #1
		MOV	R10, R0
		B	loc_404
@ ---------------------------------------------------------------------------

loc_37E:				
		ADDS.W	R11, R11, #4
		ADDS.W	R8, R8,	#4
		B	loc_344
@ ---------------------------------------------------------------------------

loc_388:				
		MOVS	R0, #0
		MOV	R11, R0
		MOV	R8, R4

loc_38E:				
		UXTH.W	R11, R11
		CMP.W	R11, #0x200
		BCS	loc_3C6
		UXTH.W	R11, R11
		LDR.W	R0, =0x2003F800
		LDRH.W	R0, [R11,R0]
		MOV	R9, R0
		MOV	R1, R9
		UXTH	R1, R1
		MOV	R0, R8
		BL	write_work_flash
		MOV	R10, R0
		UXTH.W	R10, R10
		CMP.W	R10, #0
		BNE	loc_3C6
		ADDS.W	R11, R11, #2
		ADDS.W	R8, R8,	#2
		B	loc_38E
@ ---------------------------------------------------------------------------

loc_3C6:				
					@ do_some_write+13Ej
		MOVS	R0, #0
		BL	set_mode_user_pgm
		MOVS	R0, #0
		MOV	R11, R0
		MOV	R8, R4

loc_3D2:				
		UXTH.W	R11, R11
		CMP.W	R11, #0x200
		BCS	loc_404
		UXTH.W	R11, R11
		LDR.W	R0, =0x2003F800
		LDR.W	R0, [R11,R0]
		MOVS	R7, R0
		LDR.W	R0, [R8]
		MOVS	R6, R0
		CMP	R6, R7
		BEQ	loc_3FA
		MOVS	R0, #1
		MOV	R10, R0
		B	loc_404
@ ---------------------------------------------------------------------------

loc_3FA:				
		ADDS.W	R11, R11, #4
		ADDS.W	R8, R8,	#4
		B	loc_3D2
@ ---------------------------------------------------------------------------

loc_404:				
					@ do_some_write+EEj ...
		UXTH.W	R10, R10
		CMP.W	R10, #0
		BNE	loc_420
		MOVS	R0, #0x31
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		B	loc_49E
@ ---------------------------------------------------------------------------

loc_420:				
		MOVS	R0, #0x34
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS.W	R0, R8,LSR#24
		LDR.W	R1, =0x2003F800
		STRB	R0, [R1]
		MOVS.W	R0, R8,LSR#16
		LDR.W	R1, =0x2003F801
		STRB	R0, [R1]
		MOVS.W	R0, R8,LSR#8
		LDR.W	R1, =0x2003F802
		STRB	R0, [R1]
		LDR.W	R0, =0x2003F803
		STRB.W	R8, [R0]
		MOVS	R2, #1
		MOVS	R1, #4
		LDR.W	R0, =0x2003F800
		BL	transfer
		UXTH.W	R9, R9
		MOVS.W	R0, R9,LSR#8
		LDR.W	R1, =0x2003F800
		STRB	R0, [R1]
		LDR.W	R0, =0x2003F801
		STRB.W	R9, [R0]
		MOVS	R2, #1
		MOVS	R1, #2
		LDR.W	R0, =0x2003F800
		BL	transfer
		LSRS	R0, R6,	#8
		LDR.W	R1, =0x2003F800
		STRB	R0, [R1]
		LDR.W	R0, =0x2003F801
		STRB	R6, [R0]
		MOVS	R2, #1
		MOVS	R1, #2
		LDR.W	R0, =0x2003F800
		BL	transfer

loc_49E:				
		MOV	R0, R10
		UXTH	R0, R0
		POP.W	{R1,R4-R11,PC}
@ End of function do_some_write


@ =============== S U B	R O U T	I N E =======================================


do_read:				

var_28		= -0x28

		PUSH.W	{R3-R11,LR}
		adr	R0, baz
		MOVS	R4, R0
		MOVS	R5, R1
		MOVS	R0, #0
		MOVS	R6, R0
		MOVS	R0, #'0'
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R0, #'1'
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R0, #0
		BL	set_mode_user_pgm
		MOVS	R7, R4
		MOV	R8, R7
		MOVS	R0, #0
		MOV	R10, R0
		MOVS	R0, #0
		MOV	R11, R0

loc_4E4:				
		UXTH	R5, R5
		MOVS	R0, #0x40
		SDIV.W	R0, R5,	R0
		UXTH.W	R11, R11
		CMP	R11, R0
		BGE	loc_50E
		MOVS	R2, #1
		MOVS	R1, #0x40
		UXTH.W	R10, R10
		ADDS.W	R0, R10, R7
		BL	transfer
		ADDS.W	R10, R10, #0x40
		ADDS.W	R11, R11, #1
		B	loc_4E4
@ ---------------------------------------------------------------------------

loc_50E:				
		UXTH	R5, R5
		MOVS	R1, R5
		MOV	R0, R8
		BL	compute_crc
		MOV	R9, R0
		UXTH.W	R9, R9
		MOVS.W	R0, R9,LSR#8
		LDR	R1, =0x2003F800
		STRB	R0, [R1]
		LDR	R0, =0x2003F801
		STRB.W	R9, [R0]
		MOVS	R2, #1
		MOVS	R1, #2
		LDR	R0, =0x2003F800
		BL	transfer
		MOVS	R0, '1'
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R0, R6
		UXTH	R0, R0
		POP.W	{R1,R4-R11,PC}
@ End of function do_read


@ =============== S U B	R O U T	I N E =======================================


vfy_blank:				

var_18		= -0x18

		PUSH	{R3-R7,LR}
		MOVS	R4, R0
		MOVS	R5, R1
		MOVS	R0, #0
		BL	set_mode_user_pgm
		MOVS	R0, #0
		MOVS	R6, R0
		MOVS	R0, #0x30
		STRB.W	R0, [SP,#0x18+var_18]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x18+var_18
		BL	transfer
		MOVS	R7, R4

loc_570:				
		CMP	R4, R5
		BCS	loc_588
		LDR	R0, [R7]
		CMN.W	R0, #1
		BEQ	loc_582
		MOVS	R0, #1
		MOVS	R6, R0
		B	loc_588
@ ---------------------------------------------------------------------------

loc_582:				
		ADDS	R4, R4,	#4
		ADDS	R7, R7,	#4
		B	loc_570
@ ---------------------------------------------------------------------------

loc_588:				
		UXTH	R6, R6
		CMP	R6, #0
		BEQ	loc_5EC
		MOVS	R0, #0
		MOVS	R6, R0
		MOVS	R0, #0x34
		STRB.W	R0, [SP,#0x18+var_18]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x18+var_18
		BL	transfer
		LSRS	R0, R4,	#0x18
		LDR	R1, =0x2003F800
		STRB	R0, [R1]
		LSRS	R0, R4,	#0x10
		LDR	R1, =0x2003F801
		STRB	R0, [R1]
		LSRS	R0, R4,	#8
		LDR	R1, =0x2003F802
		STRB	R0, [R1]
		LDR	R0, =0x2003F803
		STRB	R4, [R0]
		MOVS	R2, #1
		MOVS	R1, #4
		LDR	R0, =0x2003F800
		BL	transfer
		LDR	R0, [R7]
		LSRS	R0, R0,	#0x18
		LDR	R1, =0x2003F800
		STRB	R0, [R1]
		LDR	R0, [R7]
		LSRS	R0, R0,	#0x10
		LDR	R1, =0x2003F801
		STRB	R0, [R1]
		LDR	R0, [R7]
		LSRS	R0, R0,	#8
		LDR	R1, =0x2003F802
		STRB	R0, [R1]
		LDR	R0, [R7]
		LDR	R1, =0x2003F803
		STRB	R0, [R1]
		MOVS	R2, #1
		MOVS	R1, #4
		LDR	R0, =0x2003F800
		BL	transfer
		B	loc_5FC
@ ---------------------------------------------------------------------------

loc_5EC:				
		MOVS	R0, #0x31
		STRB.W	R0, [SP,#0x18+var_18]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x18+var_18
		BL	transfer

loc_5FC:				
		MOVS	R0, R6
		UXTH	R0, R0
		POP	{R1,R4-R7,PC}
@ End of function vfy_blank


@ =============== S U B	R O U T	I N E =======================================


write_sector:				
		PUSH.W	{R3-R9,LR}
		MOVS	R4, R0
		MOVS	R5, R1
		MOVS	R0, #0
		MOV	R9, R0
		MOV	R8, R4
		MOVW	R0, #0xAA8
		MOVS	R6, R0
		MOVW	R0, #0x554
		MOVS	R7, R0
		MOVS	R0, #0xAA
		STRH	R0, [R6]
		MOVS	R0, #0x55
		STRH	R0, [R7]
		MOVS	R0, #0xA0
		STRH	R0, [R6]
		STRH.W	R5, [R8]
		MOVS	R1, R5
		UXTH	R1, R1
		MOVS	R0, R4
		BL	sub_8BC
		MOV	R9, R0
		MOV	R0, R9
		UXTH	R0, R0
		POP.W	{R1,R4-R9,PC}
@ End of function write_sector


@ =============== S U B	R O U T	I N E =======================================


write_work_flash:			
		PUSH.W	{R3-R9,LR}
		MOVS	R4, R0
		MOVS	R5, R1
		MOVS	R0, #0
		MOV	R9, R0
		MOV	R8, R4
		LDR	R0, =0x200C0AA8
		MOVS	R6, R0
		LDR	R0, =0x200C0554
		MOVS	R7, R0
		MOVS	R0, #0xAA
		STRH	R0, [R6]
		MOVS	R0, #0x55
		STRH	R0, [R7]
		MOVS	R0, #0xA0
		STRH	R0, [R6]
		STRH.W	R5, [R8]
		MOVS	R1, R5
		UXTH	R1, R1
		MOVS	R0, R4
		BL	sub_8BC
		MOV	R9, R0
		MOV	R0, R9
		UXTH	R0, R0
		POP.W	{R1,R4-R9,PC}
@ End of function write_work_flash


@ =============== S U B	R O U T	I N E =======================================


chip_erase_work:			
		PUSH	{R3-R7,LR}
		MOVS	R4, R0
		MOVS	R0, #0
		MOVS	R7, R0
		LDR	R0, =0x200C0AA8
		MOVS	R5, R0
		LDR	R0, =0x200C0554
		MOVS	R6, R0
		MOVS	R0, #0xAA
		STRH	R0, [R5]
		MOVS	R0, #0x55
		STRH	R0, [R6]
		MOVS	R0, #0x80
		STRH	R0, [R5]
		MOVS	R0, #0xAA
		STRH	R0, [R5]
		MOVS	R0, #0x55
		STRH	R0, [R6]
		MOVS	R0, #0x10
		STRH	R0, [R5]
		MOVW	R1, #0xFFFF
		MOVS	R0, R5
		BL	sub_8BC
		MOVS	R7, R0
		UXTH	R7, R7
		CMP	R7, #0
		BEQ	chip_erase
		MOVS	R0, R7
		UXTH	R0, R0
		B	locret_6EE
@ ---------------------------------------------------------------------------

chip_erase:				
		MOVW	R0, #0xAA8
		MOVS	R5, R0
		MOVW	R0, #0x554
		MOVS	R6, R0
		MOVS	R0, #0xAA
		STRH	R0, [R5]
		MOVS	R0, #0x55
		STRH	R0, [R6]
		MOVS	R0, #0x80
		STRH	R0, [R5]
		MOVS	R0, #0xAA
		STRH	R0, [R5]
		MOVS	R0, #0x55
		STRH	R0, [R6]
		MOVS	R0, #0x10
		STRH	R0, [R5]
		MOVW	R1, #0xFFFF
		MOVS	R0, R5
		BL	sub_8BC
		MOVS	R7, R0
		MOVS	R0, R7
		UXTH	R0, R0

locret_6EE:				
		POP	{R1,R4-R7,PC}
@ End of function chip_erase_work


@ =============== S U B	R O U T	I N E =======================================


read_out:				

var_20		= -0x20

		PUSH.W	{R3-R9,LR}
		MOVS	R4, R0
		MOVS	R0, #0
		MOVS	R7, R0
		MOVS	R0, #'0'
		STRB.W	R0, [SP,#0x20+var_20]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x20+var_20
		BL	transfer
		LDR	R0, =0x402000
		MOVS	R5, R0
		LDR	R0, [R5]
		MOV	R8, R0
		LDR	R0, =0x40000100
		MOVS	R6, R0
		LDR	R0, [R6]
		MOV	R9, R0
		LDR	R0, =0x2003F800
		STRB.W	R8, [R0]
		MOVS.W	R0, R8,LSR#8
		LDR	R1, =0x2003F801
		STRB	R0, [R1]
		MOVS.W	R0, R8,LSR#16
		LDR	R1, =0x2003F802
		STRB	R0, [R1]
		MOVS.W	R0, R8,LSR#24
		LDR	R1, =0x2003F803
		STRB	R0, [R1]
		LDR	R0, =0x2003F804
		STRB.W	R9, [R0]
		MOVS.W	R0, R9,LSR#8
		LDR	R1, =0x2003F805
		STRB	R0, [R1]
		MOVS.W	R0, R9,LSR#16
		LDR	R1, =0x2003F806
		STRB	R0, [R1]
		MOVS.W	R0, R9,LSR#24
		LDR	R1, =0x2003F807
		STRB	R0, [R1]
		MOVS	R2, #1
		MOVS	R1, #8
		LDR	R0, =0x2003F800
		BL	transfer
		UXTH	R7, R7
		CMP	R7, #0
		BNE	loc_76E
		MOVS	R0, #'1'
		STRB.W	R0, [SP,#0x20+var_20]
		B	loc_774
@ ---------------------------------------------------------------------------

loc_76E:				
		MOVS	R0, #'4'
		STRB.W	R0, [SP,#0x20+var_20]

loc_774:				
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x20+var_20
		BL	transfer
		MOVS	R0, R7
		UXTH	R0, R0
		POP.W	{R1,R4-R9,PC}
@ End of function read_out


@ =============== S U B	R O U T	I N E =======================================


write_flash:				

var_28		= -0x28

		PUSH.W	{R3-R11,LR}
		MOVS	R4, R0
		MOVS	R0, #0
		MOV	R9, R0
		MOVW	R0, #0xAA8
		MOVS	R5, R0
		MOVW	R0, #0x554
		MOVS	R6, R0
		LDR	R0, =0x402000
		MOVS	R7, R0
		LDR	R0, =0x402002
		MOV	R8, R0
		MOVS	R0, #0x30
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R0, #1
		BL	set_mode_user_pgm
		MOVS	R0, R4
		MOV	R10, R0
		MOVS	R0, #0xAA
		STRH	R0, [R5]
		MOVS	R0, #0x55
		STRH	R0, [R6]
		MOVS	R0, #0xA0
		STRH	R0, [R5]
		STRH.W	R10, [R7]
		MOV	R1, R10
		UXTH	R1, R1
		LDR	R0, =0x402000
		BL	sub_8BC
		MOV	R9, R0
		LDRH	R0, [R7]
		MOV	R11, R0
		UXTH.W	R11, R11
		UXTH.W	R10, R10
		CMP	R11, R10
		BEQ	loc_7EE
		MOVS	R0, #1
		MOV	R9, R0

loc_7EE:				
		LSRS	R0, R4,	#0x10
		MOV	R10, R0
		MOVS	R0, #0xAA
		STRH	R0, [R5]
		MOVS	R0, #0x55
		STRH	R0, [R6]
		MOVS	R0, #0xA0
		STRH	R0, [R5]
		STRH.W	R10, [R8]
		MOV	R1, R10
		UXTH	R1, R1
		LDR	R0, =0x402002
		BL	sub_8BC
		MOV	R9, R0
		LDRH.W	R0, [R8]
		MOV	R11, R0
		UXTH.W	R11, R11
		UXTH.W	R10, R10
		CMP	R11, R10
		BEQ	loc_824
		MOVS	R0, #1
		MOV	R9, R0

loc_824:				
		MOVS	R0, #0
		BL	set_mode_user_pgm
		UXTH.W	R9, R9
		CMP.W	R9, #0
		BNE	loc_83C
		MOVS	R0, #0x31
		STRB.W	R0, [SP,#0x28+var_28]
		B	loc_842
@ ---------------------------------------------------------------------------

loc_83C:				
		MOVS	R0, #0x34
		STRB.W	R0, [SP,#0x28+var_28]

loc_842:				
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOV	R0, R9
		UXTH	R0, R0
		POP.W	{R1,R4-R11,PC}
@ End of function write_flash


@ =============== S U B	R O U T	I N E =======================================


set_mode_user_pgm:			
		UXTB	R0, R0
		CMP	R0, #0
		BEQ	User_mode
		MOVS	R3, #1
		MOVS	R1, R3
		MOVS	R3, #0
		MOVS	R2, R3
		B	loc_86C
@ ---------------------------------------------------------------------------

User_mode:				
		MOVS	R3, #2
		MOVS	R1, R3
		MOVS	R3, #1
		MOVS	R2, R3

loc_86C:				
		MOVS.W	R3, #0x40000000
		STRB	R1, [R3]
		LDR	R3, =0x200E0000
		STRB	R2, [R3]
		BX	LR
@ End of function set_mode_user_pgm

@ =============== S U B	R O U T	I N E =======================================


sub_8BC:				
					@ write_work_flash+2Cp	...

var_C		= -0xC

		PUSH	{R3-R5}
		MOVS	R2, R0
		MOVS	R3, R2
		ANDS.W	R5, R1,	#0x80
		MOVS	R4, R5
		MOVS	R5, #0
		MOVS	R0, R5

loc_8CC:				
		LDRH	R5, [R3]
		STRH.W	R5, [SP,#0xC+var_C]
		LDRH.W	R5, [SP,#0xC+var_C]
		ANDS.W	R5, R5,	#0x80
		UXTH	R4, R4
		CMP	R5, R4
		BEQ	loc_900
		LDRH.W	R5, [SP,#0xC+var_C]
		LSLS	R5, R5,	#0x1A
		BPL	loc_8CC
		LDRH	R5, [R3]
		STRH.W	R5, [SP,#0xC+var_C]
		LDRH.W	R5, [SP,#0xC+var_C]
		ANDS.W	R5, R5,	#0x80
		UXTH	R4, R4
		CMP	R5, R4
		BEQ	loc_900
		MOVS	R5, #1
		MOVS	R0, R5

loc_900:				
		UXTH	R0, R0
		POP	{R1,R4,R5}
		BX	LR
@ End of function sub_8BC


@ =============== S U B	R O U T	I N E =======================================


compute_crc:				
		PUSH	{R4,R5}
		MOVS	R2, R0
		MOVS	R5, #0
		MOVS	R0, R5
		MOVS	R5, #0
		MOVS	R3, R5

loc_912:				
		CMP	R3, R1
		BGE	loc_940
		LDRB	R5, [R2]
		EORS.W	R0, R0,	R5,LSL#8
		ADDS	R2, R2,	#1
		MOVS	R5, #0
		MOVS	R4, R5

loc_922:				
		CMP	R4, #8
		BGE	loc_93C
		LSLS	R5, R0,	#0x10
		BPL	loc_936
		LSLS	R0, R0,	#1
		EOR.W	R0, R0,	#0x1000
		EORS.W	R0, R0,	#0x21
		B	loc_938
@ ---------------------------------------------------------------------------

loc_936:				
		LSLS	R0, R0,	#1

loc_938:				
		ADDS	R4, R4,	#1
		B	loc_922
@ ---------------------------------------------------------------------------

loc_93C:				
		ADDS	R3, R3,	#1
		B	loc_912
@ ---------------------------------------------------------------------------

loc_940:				
		UXTH	R0, R0
		POP	{R4,R5}
		BX	LR
@ End of function compute_crc

@ =============== S U B	R O U T	I N E =======================================


sub_948:				
		MOVS	R0, #0
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		UXTB	R1, R1
		CMP	R1, #0
		BNE	loc_95A
		UXTB	R0, R0
		B	locret_9EC
@ ---------------------------------------------------------------------------

loc_95A:				
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		UXTB	R1, R1
		LSLS	R1, R1,	#0x1F
		BPL	loc_976
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		ANDS.W	R1, R1,	#0xFE
		LDR.W	R2, =0x40042140
		STRB	R1, [R2]

loc_976:				
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		UXTB	R1, R1
		LSLS	R1, R1,	#0x1A
		BPL	loc_992
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		ANDS.W	R1, R1,	#0xDF
		LDR.W	R2, =0x40042140
		STRB	R1, [R2]

loc_992:				
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		UXTB	R1, R1
		LSLS	R1, R1,	#0x1D
		BPL	loc_9AE
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		ANDS.W	R1, R1,	#0xFB
		LDR.W	R2, =0x40042140
		STRB	R1, [R2]

loc_9AE:				
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		UXTB	R1, R1
		LSLS	R1, R1,	#0x1C
		BPL	loc_9CE
		MOVS	R1, #1
		MOVS	R0, R1
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		ANDS.W	R1, R1,	#0xF7
		LDR.W	R2, =0x40042140
		STRB	R1, [R2]

loc_9CE:				
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		UXTB	R1, R1
		LSLS	R1, R1,	#0x1B
		BPL	loc_9EA
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		ANDS.W	R1, R1,	#0xEF
		LDR.W	R2, =0x40042140
		STRB	R1, [R2]

loc_9EA:				
		UXTB	R0, R0

locret_9EC:				
		BX	LR
@ End of function sub_948


@ =============== S U B	R O U T	I N E =======================================


sub_9EE:				
		PUSH	{R4,R5}
		MOVS	R2, #0
		LDR	R4, [R0,#0x30]
		MOVS	R3, R4
		LDRB.W	R4, [R0,#0x21]
		CMP	R4, #1
		BEQ	loc_A9E
		LDRB.W	R4, [R0,#0x21]
		CMP	R4, #2
		BNE	loc_A78
		LDR	R4, [R0,#8]
		LDR	R5, [R0,#0xC]
		CMP	R4, R5
		BCC	loc_A20
		LDR	R4, [R0,#8]
		LDR	R5, [R0,#0xC]
		SUBS	R4, R4,	R5
		MOVS	R2, R4
		CMP	R2, #0
		BNE	loc_A2C
		LDR	R4, [R0,#0x18]
		MOVS	R2, R4
		B	loc_A2C
@ ---------------------------------------------------------------------------

loc_A20:				
		LDR	R4, [R0,#0x18]
		LDR	R5, [R0,#0xC]
		SUBS	R4, R4,	R5
		LDR	R5, [R0,#8]
		ADDS	R4, R5,	R4
		MOVS	R2, R4

loc_A2C:				
		SUBS	R2, R2,	#1
		LDR	R4, [R0,#0x2C]
		LDRB	R4, [R4]
		CMP	R2, R4
		BLT	loc_A78
		LDR	R4, [R0,#0x2C]
		LDRB	R4, [R4]
		CMP	R4, R2
		BGE	loc_A44
		LDR	R2, [R0,#0x2C]
		LDRB	R2, [R2]
		B	loc_A44

loc_A44:				
		STRH	R2, [R0,#0x14]
		MOVS	R4, #0
		MOVS	R1, R4

loc_A4A:				
		CMP	R2, #1
		BLT	loc_A78
		LSLS	R4, R1,	#0x1F
		BPL	loc_A5A
		LDR	R4, [R0,#0xC]
		LDRB	R5, [R3,#1]
		STRB	R5, [R4]
		B	loc_A60
@ ---------------------------------------------------------------------------

loc_A5A:				
		LDR	R4, [R0,#0xC]
		LDRB	R5, [R3]
		STRB	R5, [R4]

loc_A60:				
		LDR	R4, [R0,#0xC]
		ADDS	R4, R4,	#1
		STR	R4, [R0,#0xC]
		LDR	R4, [R0,#4]
		LDR	R5, [R0,#0xC]
		CMP	R4, R5
		BCS	loc_A72
		LDR	R4, [R0]
		STR	R4, [R0,#0xC]

loc_A72:				
		SUBS	R2, R2,	#1
		ADDS	R1, R1,	#1
		B	loc_A4A
@ ---------------------------------------------------------------------------

loc_A78:				
		CMP	R2, #0
		BNE	loc_A8C
		LDR	R4, [R0,#0x2C]
		LDRH	R4, [R4]
		MOVW	R5, #0xFBFF
		ANDS	R4, R5
		LDR	R5, [R0,#0x2C]
		STRH	R4, [R5]
		B	loc_A9E
@ ---------------------------------------------------------------------------

loc_A8C:				
		LDR	R4, [R0,#0x2C]
		LDRH	R4, [R4]
		MOVW	R5, #0xBFFF
		ANDS	R4, R5
		LDR	R5, [R0,#0x2C]
		STRH	R4, [R5]
		LDR	R4, =0x2003EA08
		STR	R0, [R4]

loc_A9E:				
		POP	{R4,R5}
		BX	LR
@ End of function sub_9EE


@ =============== S U B	R O U T	I N E =======================================


sub_AA2:				
		PUSH	{R4-R6,LR}
		MOVS	R6, #0
		BL	sub_948
		MOVS	R6, R0
		UXTB	R6, R6
		CMP	R6, #0
		BNE	loc_B32
		LDR	R0, =0x2003E86C
		LDR	R0, [R0]
		BL	sub_B38
		MOVS	R0, #0
		MOVS	R4, R0

loc_ABE:				
		CMP	R4, #5
		BGE	loc_B32
		LDR	R0, =0x2003E870
		LDR.W	R0, [R0,R4,LSL#2]
		MOVS	R5, R0
		LDRB.W	R0, [R5,#0x22]
		CMP	R0, #3
		BNE	loc_B2E
		LDR	R0, [R5,#0x2C]
		LDRH	R0, [R0]
		ANDS.W	R0, R0,	#0x8200
		CMP.W	R0, #0x200
		BNE	loc_AEE
		LDR	R0, [R5,#0x2C]
		LDRH	R0, [R0]
		MOVW	R1, #0xFDFF
		ANDS	R0, R1
		LDR	R1, [R5,#0x2C]
		STRH	R0, [R1]

loc_AEE:				
		LDR	R0, [R5,#0x2C]
		LDRH	R0, [R0]
		LSLS	R0, R0,	#0x15
		BPL	loc_B2E
		CMP	R4, #1
		BNE	loc_B14
		LDR	R0, [R5,#0x2C]
		LDRH	R0, [R0]
		MOVW	R1, #0xFBFF
		ANDS	R0, R1
		LDR	R1, [R5,#0x2C]
		STRH	R0, [R1]
		LDRH	R0, [R5,#0x14]
		CMP	R0, #0
		BEQ	loc_B2E
		MOVS	R0, #0
		STRH	R0, [R5,#0x14]
		B	loc_B2E
@ ---------------------------------------------------------------------------

loc_B14:				
		CMP	R4, #2
		BNE	loc_B28
		LDR	R0, [R5,#0x2C]
		LDRH	R0, [R0]
		MOVW	R1, #0xFBFF
		ANDS	R0, R1
		LDR	R1, [R5,#0x2C]
		STRH	R0, [R1]
		B	loc_B2E
@ ---------------------------------------------------------------------------

loc_B28:	
		MOVS	R0, R5
		BL	sub_9EE

loc_B2E:
		ADDS	R4, R4,	#1
		B	loc_ABE
@ ---------------------------------------------------------------------------

loc_B32:
		MOVS	R0, R6
		UXTB	R0, R0
		POP	{R4-R6,PC}
@ End of function sub_AA2


@ =============== S U B	R O U T	I N E =======================================


sub_B38:
		PUSH	{R4-R6}
		MOVS	R3, #0
		LDR	R5, =0x40042148
		LDRH	R5, [R5]
		UXTH	R5, R5
		LSLS	R5, R5,	#0x15
		BPL	loc_C0E
		LDR	R5, =0x40042140
		LDRB	R5, [R5]
		UXTB	R5, R5
		LSLS	R5, R5,	#0x1E
		BMI	loc_BA4
		LDR	R5, =0x40042148
		LDRH	R5, [R5]
		UXTH	R5, R5
		ANDS.W	R5, R5,	#0x3F
		MOVS	R1, R5
		CMP	R1, #0
		BNE	loc_B68
		LDR	R5, =0x40042160
		LDRSH.W	R5, [R5]
		B	loc_B96
@ ---------------------------------------------------------------------------

loc_B68:
		LDR	R5, [R0,#4]
		MOVS	R2, R5

loc_B6C:	
		CMP	R1, #2
		BLT	loc_B7C
		LDR	R5, =0x40042160
		LDRH	R5, [R5]
		STRH	R5, [R2]
		ADDS	R2, R2,	#2
		SUBS	R1, R1,	#2
		B	loc_B6C
@ ---------------------------------------------------------------------------

loc_B7C:
		CMP	R1, #0
		BEQ	loc_B86
		LDR	R5, =0x40042160
		LDRB	R5, [R5]
		STRB	R5, [R2]

loc_B86:	
		MOVS	R5, #0
		STRH	R5, [R0,#8]
		LDR	R5, =0x40042144
		LDRH	R5, [R5]
		ORRS.W	R5, R5,	#0x4000
		LDR	R6, =0x40042144
		STRH	R5, [R6]

loc_B96:
		LDR	R5, =0x40042148
		LDRH	R5, [R5]
		MOVW	R6, #0xFBFF
		ANDS	R5, R6
		LDR	R6, =0x40042148
		STRH	R5, [R6]

loc_BA4:				
		LDRH	R5, [R0,#8]
		CMP	R5, #0
		BEQ	loc_BE6

loc_BAA:				
		LDR	R5, =0x40042144
		LDRH	R5, [R5]
		LSLS	R5, R5,	#0x15
		BPL	loc_BAA
		LDR	R5, [R0]
		MOVS	R2, R5
		LDRH	R5, [R0,#8]
		MOVS	R1, R5

loc_BBA:				
		CMP	R1, #2
		BLT	loc_BCC
		LDRH	R5, [R2]
		MOVS	R4, R5
		LDR	R5, =0x40042160
		STRH	R4, [R5]
		ADDS	R2, R2,	#2
		SUBS	R1, R1,	#2
		B	loc_BBA
@ ---------------------------------------------------------------------------

loc_BCC:				
		CMP	R1, #0
		BEQ	loc_BD6
		LDR	R5, =0x40042160
		LDRB	R6, [R2]
		STRB	R6, [R5]

loc_BD6:				
		MOVS	R5, #0
		STRH	R5, [R0,#8]
		LDR	R5, =0x40042144
		LDRH	R5, [R5]
		ORRS.W	R5, R5,	#0x4000
		LDR	R6, =0x40042144
		STRH	R5, [R6]

loc_BE6:				
		CMP	R3, #1
		BNE	loc_C0E

loc_BEA:				
		LDR	R5, =0x40042144
		LDRH	R5, [R5]
		LSLS	R5, R5,	#0x15
		BPL	loc_BEA
		LDR	R5, =0x40042144
		LDRH	R5, [R5]
		MOVW	R6, #0xFBFF
		ANDS	R5, R6
		LDR	R6, =0x40042144
		STRH	R5, [R6]
		LDR	R5, =0x40042144
		LDRH	R5, [R5]
		MOVW	R6, #0xBFFF
		ANDS	R5, R6
		LDR	R6, =0x40042144
		STRH	R5, [R6]
loc_C0E:	
		POP	{R4-R6}
		BX	LR
@ End of function sub_B38

.pool

@ =============== S U B	R O U T	I N E =======================================


sub_C12:				
		PUSH	{R4,R5}
		MOVS	R3, R0
		LDRB.W	R0, [R3,#0x34]
		CMP	R0, #0
		BNE	loc_C22
		MOVS	R0, #0
		B	loc_C5A
@ ---------------------------------------------------------------------------

loc_C22:				
		LDRB.W	R0, [R3,#0x21]
		CMP	R0, #2
		BEQ	loc_C2E
		MOVS	R0, #0
		B	loc_C5A
@ ---------------------------------------------------------------------------

loc_C2E:				
		LDR	R0, [R3,#8]
		MOVS	R5, R0
		MOVS	R0, #0
		MOVS	R4, R0

loc_C36:				
		CMP	R4, R2
		BCS	loc_C56
		LDR	R0, [R3,#0xC]
		CMP	R5, R0
		BEQ	loc_C56
		LDRB	R0, [R5]
		STRB	R0, [R1]
		ADDS	R5, R5,	#1
		ADDS	R1, R1,	#1
		LDR	R0, [R3,#4]
		CMP	R0, R5
		BCS	loc_C52
		LDR	R0, [R3]
		MOVS	R5, R0

loc_C52:				
		ADDS	R4, R4,	#1
		B	loc_C36
@ ---------------------------------------------------------------------------

loc_C56:				
		STR	R5, [R3,#8]
		MOVS	R0, R4

loc_C5A:				
		POP	{R4,R5}
		BX	LR
@ End of function sub_C12


@ =============== S U B	R O U T	I N E =======================================


sub_C5E:				
		PUSH	{R4-R7}
		MOVS	R3, R0
		LDRH	R0, [R3,#0x14]
		CMP	R0, #0
		BEQ	loc_C6C
		MOVS	R0, #0
		B	loc_CAC
@ ---------------------------------------------------------------------------

loc_C6C:				
		LDR	R0, [R3,#0x2C]
		LDRH	R0, [R0]
		LSLS	R0, R0,	#0x15
		BMI	loc_C78
		MOVS	R0, #0
		B	loc_CAC
@ ---------------------------------------------------------------------------

loc_C78:				
		MOVS	R7, R2
		LDR	R0, [R3,#0x30]
		MOVS	R6, R0
		LDRH	R0, [R3,#0x1C]
		CMP	R7, R0
		BLT	loc_C86
		LDRH	R7, [R3,#0x1C]

loc_C86:
		MOVS	R5, R7
		MOVS	R0, #0
		MOVS	R4, R0

loc_C8C:	
		CMP	R7, #1
		BLT	loc_CA8
		LSLS	R0, R4,	#0x1F
		BPL	loc_C9C
		LDRB	R0, [R1]
		STRB	R0, [R6,#1]
		ADDS	R1, R1,	#1
		B	loc_CA2
@ ---------------------------------------------------------------------------

loc_C9C:				
		LDRB	R0, [R1]
		STRB	R0, [R6]
		ADDS	R1, R1,	#1

loc_CA2:				
		SUBS	R7, R7,	#1
		ADDS	R4, R4,	#1
		B	loc_C8C
@ ---------------------------------------------------------------------------

loc_CA8:				
		STRH	R5, [R3,#0x14]
		MOVS	R0, R5

loc_CAC:				
		POP	{R4-R7}
		BX	LR
@ End of function sub_C5E

@ ---------------------------------------------------------------------------

loc_CCC:				
		BL	sub_CE2
		CMP	R0, #0
		BEQ	loc_CD8
		NOP
		NOP

loc_CD8:				
		MOVS	R0, #0
		BL	sub_0
		BL	sub_CE6

@ =============== S U B	R O U T	I N E =======================================


sub_CE2:				
		MOVS	R0, #1
		BX	LR
@ End of function sub_CE2


@ =============== S U B	R O U T	I N E =======================================

@ Attributes: noreturn

sub_CE6:				

@ FUNCTION CHUNK AT 0CF8 SIZE 00000008 BYTES

		B.W	loc_CEC
@ ---------------------------------------------------------------------------

loc_CEC:				
		MOV	R7, R0

loc_CEE:				
		MOV	R0, R7
		BL	loc_CF8
@ ---------------------------------------------------------------------------
		B	loc_CEE
@ End of function sub_CE6

@ ---------------------------------------------------------------------------
@ START	OF FUNCTION CHUNK FOR sub_CE6

loc_CF8:				
		LDR	R1, =0x20026
		MOVS	R0, #0x18
		BKPT	0xAB
		B	loc_CF8
@ END OF FUNCTION CHUNK	FOR sub_CE6
@ ---------------------------------------------------------------------------
		NOP
		NOP
		NOP
		NOP
		BL	loc_CCC
@ ---------------------------------------------------------------------------
		LDR	R0, =0x2003C001
		BX	R0
@ ---------------------------------------------------------------------------

loc_D18:				
		B.W	loc_D18
@ ---------------------------------------------------------------------------

loc_D1C:				
		B.W	loc_D1C
@ ---------------------------------------------------------------------------

loc_D20:				
		B.W	loc_D20
@ ---------------------------------------------------------------------------

loc_D24:				
		B.W	loc_D24
@ ---------------------------------------------------------------------------

loc_D28:				
		B.W	loc_D28
@ ---------------------------------------------------------------------------

loc_D2C:				
		B.W	loc_D2C
@ ---------------------------------------------------------------------------

loc_D30:				
		B.W	loc_D30
@ ---------------------------------------------------------------------------

loc_D34:				
		B.W	loc_D34
@ ---------------------------------------------------------------------------

loc_D38:				
		B.W	loc_D38
@ ---------------------------------------------------------------------------

loc_D3C:				
		B.W	loc_D3C
@ ---------------------------------------------------------------------------

loc_D40:				
		B.W	loc_D40
@ ---------------------------------------------------------------------------

loc_D44:				
		B.W	loc_D44
@ ---------------------------------------------------------------------------

loc_D48:				
		B.W	loc_D48
@ ---------------------------------------------------------------------------

loc_D4C:				
		B.W	loc_D4C
@ ---------------------------------------------------------------------------

loc_D50:				
		B.W	loc_D50
@ ---------------------------------------------------------------------------

loc_D54:				
		B.W	loc_D54
@ ---------------------------------------------------------------------------

loc_D58:				
		B.W	loc_D58
@ ---------------------------------------------------------------------------

loc_D5C:				
		B.W	loc_D5C
@ ---------------------------------------------------------------------------

loc_D60:				
		B.W	loc_D60
@ ---------------------------------------------------------------------------

loc_D64:				
		B.W	loc_D64
@ ---------------------------------------------------------------------------

loc_D68:				
		B.W	loc_D68
@ ---------------------------------------------------------------------------

loc_D6C:				
		B.W	loc_D6C
@ ---------------------------------------------------------------------------

loc_D70:				
		B.W	loc_D70
@ ---------------------------------------------------------------------------

loc_D74:				
		B.W	loc_D74
@ ---------------------------------------------------------------------------

loc_D78:				
		B.W	loc_D78
@ ---------------------------------------------------------------------------

loc_D7C:				
		B.W	loc_D7C
@ ---------------------------------------------------------------------------

loc_D80:				
		B.W	loc_D80
@ ---------------------------------------------------------------------------

loc_D84:				
		B.W	loc_D84
@ ---------------------------------------------------------------------------

loc_D88:				
		B.W	loc_D88
@ ---------------------------------------------------------------------------

loc_D8C:				
		B.W	loc_D8C
@ ---------------------------------------------------------------------------

loc_D90:				
		B.W	loc_D90
@ ---------------------------------------------------------------------------

loc_D94:				
		B.W	loc_D94
@ ---------------------------------------------------------------------------

loc_D98:				
		B.W	loc_D98
@ ---------------------------------------------------------------------------

loc_D9C:				
		B.W	loc_D9C
@ ---------------------------------------------------------------------------

loc_DA0:				
		B.W	loc_DA0
@ ---------------------------------------------------------------------------

loc_DA4:				
		B.W	loc_DA4
@ ---------------------------------------------------------------------------

loc_DA8:				
		B.W	loc_DA8
@ ---------------------------------------------------------------------------

loc_DAC:				
		B.W	loc_DAC
@ ---------------------------------------------------------------------------

loc_DB0:				
		B.W	loc_DB0
@ ---------------------------------------------------------------------------

loc_DB4:				
		B.W	loc_DB4
@ ---------------------------------------------------------------------------

loc_DB8:				
		B.W	loc_DB8
@ ---------------------------------------------------------------------------

loc_DBC:				
		B.W	loc_DBC
@ ---------------------------------------------------------------------------

loc_DC0:				
		B.W	loc_DC0
@ ---------------------------------------------------------------------------

loc_DC4:				
		B.W	loc_DC4
@ ---------------------------------------------------------------------------

loc_DC8:				
		B.W	loc_DC8
@ ---------------------------------------------------------------------------

loc_DCC:				
		B.W	loc_DCC
@ ---------------------------------------------------------------------------
.pool

.align 4

baz:            .ascii "MB9B560R Rev1.08"
		.end
