.syntax	unified
.thumb
.text
.align 4

@ =============== S U B	R O U T	I N E =======================================


sub_0:

var_18		= -0x18

		PUSH	{R3-R7,LR}
		MOVS	R0, #0
		MOVS	R6, R0
		MOVS	R0, #'1'
		STRB.W	R0, [SP,#0x18+var_18]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x18+var_18
		BL	transfer
		MOVS	R0, #'2'
		STRB.W	R0, [SP,#0x18+var_18]

loc_1C:
		MOVS	R0, #0
		MOVS	R7, R0
		MOVS	R2, #0
		MOVS	R1, #5
		LDR.W	R0, =0x20003E00
		BL	transfer
		LDR.W	R0, =0x20003E00
		LDRB	R0, [R0]
		UXTB	R0, R0
		CMP	R0, #8
		BEQ	cmd_write_sector
		CMP	R0, #0x28
		BEQ	cmd_read
		CMP	R0, #0x38
		BEQ	cmd_erase
		CMP	R0, #0x39
		BEQ.W	cmd_get_special
		CMP	R0, #0x3A
		BEQ.W	cmd_program_vfy
		CMP	R0, #0x48
		BEQ	cmd_blank
		B	loc_1B6
@ ---------------------------------------------------------------------------

cmd_erase:
		BL	do_erase
		MOVS	R6, R0
		B	loc_1C0
@ ---------------------------------------------------------------------------

cmd_write_sector:
		LDR.W	R0, =0x20003E01
		LDRB	R0, [R0]
		UXTB	R0, R0
		MOVS	R4, R0
		LDR.W	R0, =0x20003E02
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#8
		LDR.W	R0, =0x20003E03
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#16
		LDR.W	R0, =0x20003E04
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#24
		MOVW	R1, #0x202
		MOVS	R0, R4
		BL	do_some_write
		MOVS	R6, R0
		B	loc_1C0
@ ---------------------------------------------------------------------------

cmd_read:
		LDR.W	R0, =0x20003E01
		LDRB	R0, [R0]
		UXTB	R0, R0
		MOVS	R4, R0
		LDR.W	R0, =0x20003E02
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#8
		LDR.W	R0, =0x20003E03
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#16
		LDR.W	R0, =0x20003E04
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#24
		MOV.W	R1, #0x200
		MOVS	R0, R4
		BL	do_read
		MOVS	R6, R0
		B	loc_1C0
@ ---------------------------------------------------------------------------

cmd_blank:
		LDR.W	R0, =0x20003E01
		LDRB	R0, [R0]
		UXTB	R0, R0
		MOVS	R4, R0
		LDR.W	R0, =0x20003E02
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#8
		LDR.W	R0, =0x20003E03
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#16
		LDR.W	R0, =0x20003E04
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#24
		MOVS	R2, #0
		MOVS	R1, #4
		LDR.W	R0, =0x20003E00
		BL	transfer
		LDR.W	R0, =0x20003E00
		LDRB	R0, [R0]
		UXTB	R0, R0
		MOVS	R5, R0
		LDR.W	R0, =0x20003E01
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R5, R5,	R0,LSL#8
		LDR.W	R0, =0x20003E02
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R5, R5,	R0,LSL#16
		LDR.W	R0, =0x20003E03
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R5, R5,	R0,LSL#24
		MOVS	R1, R5
		MOVS	R0, R4
		BL	vfy_blank
		MOVS	R6, R0
		B	loc_1C0
@ ---------------------------------------------------------------------------

cmd_get_special:
		LDR.W	R0, =0x20003E01
		LDRB	R0, [R0]
		UXTB	R0, R0
		MOVS	R4, R0
		LDR.W	R0, =0x20003E02
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#8
		LDR.W	R0, =0x20003E03
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#16
		LDR.W	R0, =0x20003E04
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#24
		MOVS	R0, R4
		BL	sub_5CE
		MOVS	R6, R0
		B	loc_1C0
@ ---------------------------------------------------------------------------

cmd_program_vfy:
		LDR.W	R0, =0x20003E01
		LDRB	R0, [R0]
		UXTB	R0, R0
		MOVS	R4, R0
		LDR.W	R0, =0x20003E02
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#8
		LDR.W	R0, =0x20003E03
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#16
		LDR.W	R0, =0x20003E04
		LDRB	R0, [R0]
		UXTB	R0, R0
		ORRS.W	R4, R4,	R0,LSL#24
		MOVS	R0, R4
		BL	write_flash
		MOVS	R6, R0
		B	loc_1C0
@ ---------------------------------------------------------------------------

loc_1B6:
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x18+var_18
		BL	transfer

loc_1C0:
		UXTH	R6, R6
		CMP	R6, #0
		BEQ.W	loc_1C
		MOVS	R0, #1
		MOVS	R7, R0
		UXTB	R7, R7
		CMP	R7, #0
		BEQ	locret_1D4

loc_1D2:
		B	loc_1D2
@ ---------------------------------------------------------------------------

locret_1D4:
		POP	{R0,R4-R7,PC}
@ End of function sub_0

.pool

@ =============== S U B	R O U T	I N E =======================================


transfer:
		PUSH.W	{R3-R9,LR}
		MOVS	R4, R0
		MOVS	R5, R1
		MOVS	R6, R2
		UXTH	R5, R5
		MOVS	R7, R5
		MOV	R9, R4

loc_1E6:
		BL	sub_984
		MOVS	R0, #0
		MOV	R8, R0
		UXTB	R6, R6
		CMP	R6, #0
		BEQ	loc_204
		MOVS	R2, R7
		MOV	R1, R9
		LDR.W	R0, =0x20002ED8
		BL	sub_B42
		MOV	R8, R0
		B	loc_212
@ ---------------------------------------------------------------------------

loc_204:
		MOVS	R2, R7
		MOV	R1, R9
		LDR.W	R0, =0x20002EA0
		BL	sub_AF6
		MOV	R8, R0

loc_212:
		CMP	R8, R7
		BCS	loc_220
		ADDS.W	R9, R8,	R9
		SUBS.W	R7, R7,	R8
		B	loc_1E6
@ ---------------------------------------------------------------------------

loc_220:
		BL	sub_984
		MOVS	R0, #0
		POP.W	{R1,R4-R9,PC}
@ End of function transfer


@ =============== S U B	R O U T	I N E =======================================


do_erase:

var_10		= -0x10

		PUSH	{R4,LR}
		SUB	SP, SP,	#8
		MOVS	R0, #0
		MOVS	R4, R0
		MOVS	R0, #'0'
		STRB.W	R0, [SP,#0x10+var_10]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x10+var_10
		BL	transfer
		MOVS	R0, #1
		BL	set_mode_user_pgm
		MOVW	R0, #0x1550
		BL	chip_erase_work
		MOVS	R4, R0
		MOVS	R0, #0
		BL	set_mode_user_pgm
		UXTH	R4, R4
		CMP	R4, #0
		BNE	loc_266
		MOVS	R0, #'1'
		STRB.W	R0, [SP,#0x10+var_10]
		B	loc_26C
@ ---------------------------------------------------------------------------

loc_266:
		MOVS	R0, #'4'
		STRB.W	R0, [SP,#0x10+var_10]

loc_26C:
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x10+var_10
		BL	transfer
		MOVS	R0, R4
		UXTH	R0, R0
		POP	{R1,R2,R4,PC}
@ End of function do_erase


@ =============== S U B	R O U T	I N E =======================================


do_some_write:

var_28		= -0x28

		PUSH.W	{R3-R11,LR}
		MOVS	R4, R0
		MOVS	R5, R1
		MOVS	R0, #0
		MOV	R8, R0
		MOVS	R0, #'0'
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R0, #'1'
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R2, #0
		MOVS	R1, R5
		UXTH	R1, R1
		LDR.W	R0, =0x20003E00
		BL	transfer
		UXTH	R5, R5
		MOVS	R1, R5
		LDR.W	R0, =0x20003E00
		BL	calculate_crc
		MOV	R9, R0
		UXTH.W	R9, R9
		CMP.W	R9, #0
		BEQ	loc_2D6
		MOVS	R0, #'5'
		STRB.W	R0, [SP,#0x28+var_28]
		B	loc_2DC
@ ---------------------------------------------------------------------------

loc_2D6:
		MOVS	R0, #'0'
		STRB.W	R0, [SP,#0x28+var_28]

loc_2DC:
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R0, #1
		BL	set_mode_user_pgm
		MOVS	R0, #0
		MOV	R10, R0
		MOV	R11, R4

loc_2F2:
		MOV.W	R0, #0x200
		UXTH.W	R10, R10
		CMP	R10, R0
		BCS	loc_340
		UXTH.W	R10, R10
		LDR.W	R0, =0x20003E00
		LDRH.W	R0, [R10,R0]
		MOVS	R7, R0
		MOVS	R1, R7
		UXTH	R1, R1
		MOV	R0, R11
		BL	write_sector
		MOV	R8, R0
		UXTH.W	R8, R8
		CMP.W	R8, #0
		BNE	loc_340
		LDRH.W	R0, [R11]
		MOVS	R6, R0
		UXTH	R6, R6
		UXTH	R7, R7
		CMP	R6, R7
		BEQ	loc_336
		MOVS	R0, #1
		MOV	R8, R0
		B	loc_340
@ ---------------------------------------------------------------------------

loc_336:
		ADDS.W	R10, R10, #2
		ADDS.W	R11, R11, #2
		B	loc_2F2
@ ---------------------------------------------------------------------------

loc_340:
		MOVS	R0, #0
		BL	set_mode_user_pgm
		UXTH.W	R8, R8
		CMP.W	R8, #0
		BNE	loc_362
		MOVS	R0, #'1'
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		B	loc_3DC
@ ---------------------------------------------------------------------------

loc_362:
		MOVS	R0, #'4'
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS.W	R0, R11,LSR#24
		LDR.W	R1, =0x20003E00
		STRB	R0, [R1]
		MOVS.W	R0, R11,LSR#16
		LDR.W	R1, =0x20003E01
		STRB	R0, [R1]
		MOVS.W	R0, R11,LSR#8
		LDR.W	R1, =0x20003E02
		STRB	R0, [R1]
		LDR.W	R0, =0x20003E03
		STRB.W	R11, [R0]
		MOVS	R2, #1
		MOVS	R1, #4
		LDR.W	R0, =0x20003E00
		BL	transfer
		UXTH	R7, R7
		LSRS	R0, R7,	#8
		LDR.W	R1, =0x20003E00
		STRB	R0, [R1]
		LDR.W	R0, =0x20003E01
		STRB	R7, [R0]
		MOVS	R2, #1
		MOVS	R1, #2
		LDR.W	R0, =0x20003E00
		BL	transfer
		UXTH	R6, R6
		LSRS	R0, R6,	#8
		LDR.W	R1, =0x20003E00
		STRB	R0, [R1]
		LDR.W	R0, =0x20003E01
		STRB	R6, [R0]
		MOVS	R2, #1
		MOVS	R1, #2
		LDR.W	R0, =0x20003E00
		BL	transfer

loc_3DC:
		MOV	R0, R8
		UXTH	R0, R0
		POP.W	{R1,R4-R11,PC}
@ End of function do_some_write

.pool

from:		.word  0x20080000
@ =============== S U B	R O U T	I N E =======================================


do_read:

var_28		= -0x28

		PUSH.W	{R3-R11,LR}
		MOVS	R4, R0
		MOVS	R5, R1
@--------------------
.if 1
		adr	r1, from
		ldr	r4, [r1]
		add.w	r0, r4, #0x200
		str	r0, [r1]	
.endif
@--------------------
		MOVS	R0, #0
		MOVS	R6, R0
		MOVS	R0, #'0'
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R0, #'1'
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R0, #0
		BL	set_mode_user_pgm
		MOVS	R7, R4
		MOV	R8, R7
		MOVS	R0, #0
		MOV	R10, R0
		MOVS	R0, #0
		MOV	R11, R0

loc_422:
		UXTH	R5, R5
		MOVS	R0, #0x40
		SDIV.W	R0, R5,	R0
		UXTH.W	R11, R11
		CMP	R11, R0
		BGE	loc_44C
		MOVS	R2, #1
		MOVS	R1, #0x40
		UXTH.W	R10, R10
		ADDS.W	R0, R10, R7
		BL	transfer
		ADDS.W	R10, R10, #0x40
		ADDS.W	R11, R11, #1
		B	loc_422
@ ---------------------------------------------------------------------------

loc_44C:
		UXTH	R5, R5
		MOVS	R1, R5
		MOV	R0, R8
		BL	calculate_crc
		MOV	R9, R0
		UXTH.W	R9, R9
		MOVS.W	R0, R9,LSR#8
		LDR	R1, =0x20003E00
		STRB	R0, [R1]
		LDR	R0, =0x20003E01
		STRB.W	R9, [R0]
		MOVS	R2, #1
		MOVS	R1, #2
		LDR	R0, =0x20003E00
		BL	transfer
		MOVS	R0, #'1'
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R0, R6
		UXTH	R0, R0
		POP.W	{R1,R4-R11,PC}
@ End of function do_read


@ =============== S U B	R O U T	I N E =======================================


vfy_blank:

var_18		= -0x18

		PUSH	{R3-R7,LR}
		MOVS	R4, R0
		MOVS	R5, R1
		MOVS	R0, #0
		BL	set_mode_user_pgm
		MOVS	R0, #0
		MOVS	R6, R0
		MOVS	R0, #'0'
		STRB.W	R0, [SP,#0x18+var_18]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x18+var_18
		BL	transfer
		MOVS	R7, R4

loc_4AE:
		CMP	R4, R5
		BCS	loc_4C6
		LDR	R0, [R7]
		CMN.W	R0, #1
		BEQ	loc_4C0
		MOVS	R0, #1
		MOVS	R6, R0
		B	loc_4C6
@ ---------------------------------------------------------------------------

loc_4C0:
		ADDS	R4, R4,	#4
		ADDS	R7, R7,	#4
		B	loc_4AE
@ ---------------------------------------------------------------------------

loc_4C6:
					@ vfy_blank+32j
		UXTH	R6, R6
		CMP	R6, #0
		BEQ	loc_52A
		MOVS	R0, #0
		MOVS	R6, R0
		MOVS	R0, #'4'
		STRB.W	R0, [SP,#0x18+var_18]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x18+var_18
		BL	transfer
		LSRS	R0, R4,	#0x18
		LDR	R1, =0x20003E00
		STRB	R0, [R1]
		LSRS	R0, R4,	#0x10
		LDR	R1, =0x20003E01
		STRB	R0, [R1]
		LSRS	R0, R4,	#8
		LDR	R1, =0x20003E02
		STRB	R0, [R1]
		LDR	R0, =0x20003E03
		STRB	R4, [R0]
		MOVS	R2, #1
		MOVS	R1, #4
		LDR	R0, =0x20003E00
		BL	transfer
		LDR	R0, [R7]
		LSRS	R0, R0,	#0x18
		LDR	R1, =0x20003E00
		STRB	R0, [R1]
		LDR	R0, [R7]
		LSRS	R0, R0,	#0x10
		LDR	R1, =0x20003E01
		STRB	R0, [R1]
		LDR	R0, [R7]
		LSRS	R0, R0,	#8
		LDR	R1, =0x20003E02
		STRB	R0, [R1]
		LDR	R0, [R7]
		LDR	R1, =0x20003E03
		STRB	R0, [R1]
		MOVS	R2, #1
		MOVS	R1, #4
		LDR	R0, =0x20003E00
		BL	transfer
		B	loc_53A
@ ---------------------------------------------------------------------------

loc_52A:
		MOVS	R0, #'1'
		STRB.W	R0, [SP,#0x18+var_18]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x18+var_18
		BL	transfer

loc_53A:
		MOVS	R0, R6
		UXTH	R0, R0
		POP	{R1,R4-R7,PC}
@ End of function vfy_blank


@ =============== S U B	R O U T	I N E =======================================


write_sector:
		PUSH.W	{R3-R9,LR}
		MOVS	R4, R0
		MOVS	R5, R1
		MOVS	R0, #0
		MOV	R9, R0
		MOV	R8, R4
		MOVW	R0, #0x1550
		MOVS	R6, R0
		MOVW	R0, #0xAA8
		MOVS	R7, R0
		MOVW	R0, #0xAAAA
		STRH	R0, [R6]
		MOVW	R0, #0x5555
		STRH	R0, [R7]
		MOVW	R0, #0xA0A0
		STRH	R0, [R6]
		STRH.W	R5, [R8]
		MOVS	R1, R5
		UXTH	R1, R1
		MOVS	R0, R4
		BL	sub_79C
		MOV	R9, R0
		MOV	R0, R9
		UXTH	R0, R0
		POP.W	{R1,R4-R9,PC}
@ End of function write_sector


@ =============== S U B	R O U T	I N E =======================================


chip_erase_work:
		PUSH	{R3-R7,LR}
		MOVS	R4, R0
		MOVS	R0, #0
		MOVS	R7, R0
		MOVW	R0, #0x1550
		MOVS	R5, R0
		MOVW	R0, #0xAA8
		MOVS	R6, R0
		MOVW	R0, #0xAAAA
		STRH	R0, [R5]
		MOVW	R0, #0x5555
		STRH	R0, [R6]
		MOVW	R0, #0x8080
		STRH	R0, [R5]
		MOVW	R0, #0xAAAA
		STRH	R0, [R5]
		MOVW	R0, #0x5555
		STRH	R0, [R6]
		MOVW	R0, #0x1010
		STRH	R0, [R5]
		MOVW	R1, #0xFFFF
		MOVS	R0, R5
		BL	sub_79C
		MOVS	R7, R0
		MOVS	R0, R7
		UXTH	R0, R0
		POP	{R1,R4-R7,PC}
@ End of function chip_erase_work


@ =============== S U B	R O U T	I N E =======================================


sub_5CE:

var_20		= -0x20

		PUSH.W	{R3-R9,LR}
		MOVS	R4, R0
		MOVS	R0, #0
		MOVS	R7, R0
		MOVS	R0, #'0'
		STRB.W	R0, [SP,#0x20+var_20]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x20+var_20
		BL	transfer
		LDR	R0, =0x101004
		MOVS	R5, R0
		LDR	R0, [R5]
		MOV	R8, R0
		LDR	R0, =0x40000100
		MOVS	R6, R0
		LDR	R0, [R6]
		MOV	R9, R0
		LDR	R0, =0x20003E00
		STRB.W	R8, [R0]
		MOVS.W	R0, R8,LSR#8
		LDR	R1, =0x20003E01
		STRB	R0, [R1]
		MOVS.W	R0, R8,LSR#16
		LDR	R1, =0x20003E02
		STRB	R0, [R1]
		MOVS.W	R0, R8,LSR#24
		LDR	R1, =0x20003E03
		STRB	R0, [R1]
		LDR	R0, =0x20003E04
		STRB.W	R9, [R0]
		MOVS.W	R0, R9,LSR#8
		LDR	R1, =0x20003E05
		STRB	R0, [R1]
		MOVS.W	R0, R9,LSR#16
		LDR	R1, =0x20003E06
		STRB	R0, [R1]
		MOVS.W	R0, R9,LSR#24
		LDR	R1, =0x20003E07
		STRB	R0, [R1]
		MOVS	R2, #1
		MOVS	R1, #8
		LDR	R0, =0x20003E00
		BL	transfer
		UXTH	R7, R7
		CMP	R7, #0
		BNE	loc_64C
		MOVS	R0, #'1'
		STRB.W	R0, [SP,#0x20+var_20]
		B	loc_652
@ ---------------------------------------------------------------------------

loc_64C:
		MOVS	R0, #'4'
		STRB.W	R0, [SP,#0x20+var_20]

loc_652:
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x20+var_20
		BL	transfer
		MOVS	R0, R7
		UXTH	R0, R0
		POP.W	{R1,R4-R9,PC}
@ End of function sub_5CE

.pool

@ =============== S U B	R O U T	I N E =======================================


write_flash:

var_28		= -0x28

		PUSH.W	{R3-R11,LR}
		MOVS	R4, R0
		MOVS	R0, #0
		MOV	R9, R0
		MOVW	R0, #0x1550
		MOVS	R5, R0
		MOVW	R0, #0xAA8
		MOVS	R6, R0
		LDR	R0, =0x101004
		MOVS	R7, R0
		LDR	R0, =0x101006
		MOV	R8, R0
		MOVS	R0, #'0'
		STRB.W	R0, [SP,#0x28+var_28]
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOVS	R0, #1
		BL	set_mode_user_pgm
		MOVS	R0, R4
		MOV	R10, R0
		MOVW	R0, #0xAAAA
		STRH	R0, [R5]
		MOVW	R0, #0x5555
		STRH	R0, [R6]
		MOVW	R0, #0xA0A0
		STRH	R0, [R5]
		STRH.W	R10, [R7]
		MOV	R1, R10
		UXTH	R1, R1
		LDR	R0, =0x101004
		BL	sub_79C
		MOV	R9, R0
		LDRH	R0, [R7]
		MOV	R11, R0
		UXTH.W	R11, R11
		UXTH.W	R10, R10
		CMP	R11, R10
		BEQ	loc_6D2
		MOVS	R0, #1
		MOV	R9, R0

loc_6D2:
		LSRS	R0, R4,	#0x10
		MOV	R10, R0
		MOVW	R0, #0xAAAA
		STRH	R0, [R5]
		MOVW	R0, #0x5555
		STRH	R0, [R6]
		MOVW	R0, #0xA0A0
		STRH	R0, [R5]
		STRH.W	R10, [R8]
		MOV	R1, R10
		UXTH	R1, R1
		LDR	R0, =0x101006
		BL	sub_79C
		MOV	R9, R0
		LDRH.W	R0, [R8]
		MOV	R11, R0
		UXTH.W	R11, R11
		UXTH.W	R10, R10
		CMP	R11, R10
		BEQ	loc_70E
		MOVS	R0, #1
		MOV	R9, R0

loc_70E:
		MOVS	R0, #0
		BL	set_mode_user_pgm
		UXTH.W	R9, R9
		CMP.W	R9, #0
		BNE	loc_726
		MOVS	R0, #'1'
		STRB.W	R0, [SP,#0x28+var_28]
		B	loc_72C
@ ---------------------------------------------------------------------------

loc_726:
		MOVS	R0, #'4'
		STRB.W	R0, [SP,#0x28+var_28]

loc_72C:
		MOVS	R2, #1
		MOVS	R1, #1
		ADD	R0, SP,	#0x28+var_28
		BL	transfer
		MOV	R0, R9
		UXTH	R0, R0
		POP.W	{R1,R4-R11,PC}
@ End of function write_flash


@ =============== S U B	R O U T	I N E =======================================


set_mode_user_pgm:
		UXTB	R0, R0
		CMP	R0, #0
		BEQ	loc_74E
		MOVS	R3, #1
		MOVS	R1, R3
		MOVS	R3, #0
		MOVS	R2, R3
		B	loc_756
@ ---------------------------------------------------------------------------

loc_74E:
		MOVS	R3, #2
		MOVS	R1, R3
		MOVS	R3, #1
		MOVS	R2, R3

loc_756:
		MOVS.W	R3, #0x40000000
		STRB	R1, [R3]
		LDR	R3, =0x200E0000
		STRB	R2, [R3]
		BX	LR
@ End of function set_mode_user_pgm

.pool

@ =============== S U B	R O U T	I N E =======================================


sub_79C:

var_C		= -0xC

		PUSH	{R3-R5}
		MOVS	R2, R0
		MOVS	R3, R2
		ANDS.W	R5, R1,	#0x80
		MOVS	R4, R5
		MOVS	R5, #0
		MOVS	R0, R5

loc_7AC:
		LDRH	R5, [R3]
		STRH.W	R5, [SP,#0xC+var_C]
		LDRH.W	R5, [SP,#0xC+var_C]
		ANDS.W	R5, R5,	#0x80
		UXTH	R4, R4
		CMP	R5, R4
		BEQ	loc_7E0
		LDRH.W	R5, [SP,#0xC+var_C]
		LSLS	R5, R5,	#0x1A
		BPL	loc_7AC
		LDRH	R5, [R3]
		STRH.W	R5, [SP,#0xC+var_C]
		LDRH.W	R5, [SP,#0xC+var_C]
		ANDS.W	R5, R5,	#0x80
		UXTH	R4, R4
		CMP	R5, R4
		BEQ	loc_7E0
		MOVS	R5, #1
		MOVS	R0, R5

loc_7E0:
		UXTH	R0, R0
		POP	{R1,R4,R5}
		BX	LR
@ End of function sub_79C


@ =============== S U B	R O U T	I N E =======================================


calculate_crc:
					@ do_read+6Ep
		PUSH	{R4,R5}
		MOVS	R2, R0
		MOVS	R5, #0
		MOVS	R0, R5
		MOVS	R5, #0
		MOVS	R3, R5

loc_7F2:
		CMP	R3, R1
		BGE	loc_820
		LDRB	R5, [R2]
		EORS.W	R0, R0,	R5,LSL#8
		ADDS	R2, R2,	#1
		MOVS	R5, #0
		MOVS	R4, R5

loc_802:
		CMP	R4, #8
		BGE	loc_81C
		LSLS	R5, R0,	#0x10
		BPL	loc_816
		LSLS	R0, R0,	#1
		EOR.W	R0, R0,	#0x1000
		EORS.W	R0, R0,	#0x21
		B	loc_818
@ ---------------------------------------------------------------------------

loc_816:
		LSLS	R0, R0,	#1

loc_818:
		ADDS	R4, R4,	#1
		B	loc_802
@ ---------------------------------------------------------------------------

loc_81C:
		ADDS	R3, R3,	#1
		B	loc_7F2
@ ---------------------------------------------------------------------------

loc_820:
		UXTH	R0, R0
		POP	{R4,R5}
		BX	LR
@ End of function calculate_crc

@ =============== S U B	R O U T	I N E =======================================


sub_828:
		MOVS	R0, #0
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		UXTB	R1, R1
		CMP	R1, #0
		BNE	loc_83A
		UXTB	R0, R0
		B	locret_8CC
@ ---------------------------------------------------------------------------

loc_83A:
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		UXTB	R1, R1
		LSLS	R1, R1,	#0x1F
		BPL	loc_856
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		ANDS.W	R1, R1,	#0xFE
		LDR.W	R2, =0x40042140
		STRB	R1, [R2]

loc_856:
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		UXTB	R1, R1
		LSLS	R1, R1,	#0x1A
		BPL	loc_872
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		ANDS.W	R1, R1,	#0xDF
		LDR.W	R2, =0x40042140
		STRB	R1, [R2]

loc_872:
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		UXTB	R1, R1
		LSLS	R1, R1,	#0x1D
		BPL	loc_88E
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		ANDS.W	R1, R1,	#0xFB
		LDR.W	R2, =0x40042140
		STRB	R1, [R2]

loc_88E:
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		UXTB	R1, R1
		LSLS	R1, R1,	#0x1C
		BPL	loc_8AE
		MOVS	R1, #1
		MOVS	R0, R1
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		ANDS.W	R1, R1,	#0xF7
		LDR.W	R2, =0x40042140
		STRB	R1, [R2]

loc_8AE:
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		UXTB	R1, R1
		LSLS	R1, R1,	#0x1B
		BPL	loc_8CA
		LDR.W	R1, =0x40042140
		LDRB	R1, [R1]
		ANDS.W	R1, R1,	#0xEF
		LDR.W	R2, =0x40042140
		STRB	R1, [R2]

loc_8CA:
		UXTB	R0, R0

locret_8CC:
		BX	LR
@ End of function sub_828


@ =============== S U B	R O U T	I N E =======================================


sub_8CE:
		PUSH	{R4,R5}
		MOVS	R2, #0
		LDR	R4, [R0,#0x30]
		MOVS	R3, R4
		LDRB.W	R4, [R0,#0x21]
		CMP	R4, #1
		BEQ	loc_980
		LDRB.W	R4, [R0,#0x21]
		CMP	R4, #2
		BNE	loc_95A
		LDR	R4, [R0,#8]
		LDR	R5, [R0,#0xC]
		CMP	R4, R5
		BCC	loc_900
		LDR	R4, [R0,#8]
		LDR	R5, [R0,#0xC]
		SUBS	R4, R4,	R5
		MOVS	R2, R4
		CMP	R2, #0
		BNE	loc_90C
		LDR	R4, [R0,#0x18]
		MOVS	R2, R4
		B	loc_90C
@ ---------------------------------------------------------------------------

loc_900:
		LDR	R4, [R0,#0x18]
		LDR	R5, [R0,#0xC]
		SUBS	R4, R4,	R5
		LDR	R5, [R0,#8]
		ADDS	R4, R5,	R4
		MOVS	R2, R4

loc_90C:
		SUBS	R2, R2,	#1
		LDR	R4, [R0,#0x2C]
		LDRB	R4, [R4]
		CMP	R2, R4
		BLT	loc_95A
		LDR	R4, [R0,#0x2C]
		LDRB	R4, [R4]
		CMP	R4, R2
		BGE	loc_924
		LDR	R2, [R0,#0x2C]
		LDRB	R2, [R2]
		B	loc_924

loc_924:
		STRH	R2, [R0,#0x14]
		MOVS	R4, #0
		MOVS	R1, R4

loc_92A:
		CMP	R2, #1
		BLT	loc_95A
		MOVS	R4, R1
		LSLS	R4, R4,	#0x1F
		BPL	loc_93C
		LDR	R4, [R0,#0xC]
		LDRB	R5, [R3,#1]
		STRB	R5, [R4]
		B	loc_942
@ ---------------------------------------------------------------------------

loc_93C:
		LDR	R4, [R0,#0xC]
		LDRB	R5, [R3]
		STRB	R5, [R4]

loc_942:
		LDR	R4, [R0,#0xC]
		ADDS	R4, R4,	#1
		STR	R4, [R0,#0xC]
		LDR	R4, [R0,#4]
		LDR	R5, [R0,#0xC]
		CMP	R4, R5
		BCS	loc_954
		LDR	R4, [R0]
		STR	R4, [R0,#0xC]

loc_954:
		SUBS	R2, R2,	#1
		ADDS	R1, R1,	#1
		B	loc_92A
@ ---------------------------------------------------------------------------

loc_95A:
		CMP	R2, #0
		BNE	loc_96E
		LDR	R4, [R0,#0x2C]
		LDRH	R4, [R4]
		MOVW	R5, #0xFBFF
		ANDS	R4, R5
		LDR	R5, [R0,#0x2C]
		STRH	R4, [R5]
		B	loc_980
@ ---------------------------------------------------------------------------

loc_96E:
		LDR	R4, [R0,#0x2C]
		LDRH	R4, [R4]
		MOVW	R5, #0xBFFF
		ANDS	R4, R5
		LDR	R5, [R0,#0x2C]
		STRH	R4, [R5]
		LDR	R4, =0x20003008
		STR	R0, [R4]

loc_980:
		POP	{R4,R5}
		BX	LR
@ End of function sub_8CE


@ =============== S U B	R O U T	I N E =======================================


sub_984:
					@ transfer:loc_220p
		PUSH	{R4-R6,LR}
		MOVS	R6, #0
		BL	sub_828
		MOVS	R6, R0
		UXTB	R6, R6
		CMP	R6, #0
		BNE	loc_A16
		LDR	R0, =0x20002E6C
		LDR	R0, [R0]
		BL	sub_A1C
		MOVS	R0, #0
		MOVS	R4, R0

loc_9A0:
		CMP	R4, #5
		BGE	loc_A16
		LDR	R0, =0x20002E70
		LDR.W	R0, [R0,R4,LSL#2]
		MOVS	R5, R0
		LDRB.W	R0, [R5,#0x22]
		CMP	R0, #3
		BNE	loc_A12
		LDR	R0, [R5,#0x2C]
		LDRH	R0, [R0]
		ANDS.W	R0, R0,	#0x8200
		MOV.W	R1, #0x200
		CMP	R0, R1
		BNE	loc_9D2
		LDR	R0, [R5,#0x2C]
		LDRH	R0, [R0]
		MOVW	R1, #0xFDFF
		ANDS	R0, R1
		LDR	R1, [R5,#0x2C]
		STRH	R0, [R1]

loc_9D2:
		LDR	R0, [R5,#0x2C]
		LDRH	R0, [R0]
		LSLS	R0, R0,	#0x15
		BPL	loc_A12
		CMP	R4, #1
		BNE	loc_9F8
		LDR	R0, [R5,#0x2C]
		LDRH	R0, [R0]
		MOVW	R1, #0xFBFF
		ANDS	R0, R1
		LDR	R1, [R5,#0x2C]
		STRH	R0, [R1]
		LDRH	R0, [R5,#0x14]
		CMP	R0, #0
		BEQ	loc_A12
		MOVS	R0, #0
		STRH	R0, [R5,#0x14]
		B	loc_A12
@ ---------------------------------------------------------------------------

loc_9F8:
		CMP	R4, #2
		BNE	loc_A0C
		LDR	R0, [R5,#0x2C]
		LDRH	R0, [R0]
		MOVW	R1, #0xFBFF
		ANDS	R0, R1
		LDR	R1, [R5,#0x2C]
		STRH	R0, [R1]
		B	loc_A12
@ ---------------------------------------------------------------------------

loc_A0C:
		MOVS	R0, R5
		BL	sub_8CE

loc_A12:
		ADDS	R4, R4,	#1
		B	loc_9A0
@ ---------------------------------------------------------------------------

loc_A16:
		MOVS	R0, R6
		UXTB	R0, R0
		POP	{R4-R6,PC}
@ End of function sub_984

.pool

@ =============== S U B	R O U T	I N E =======================================


sub_A1C:
		PUSH	{R4-R6}
		MOVS	R3, #0
		LDR	R5, =0x40042148
		LDRH	R5, [R5]
		UXTH	R5, R5
		LSLS	R5, R5,	#0x15
		BPL	loc_AF2
		LDR	R5, =0x40042140
		LDRB	R5, [R5]
		UXTB	R5, R5
		LSLS	R5, R5,	#0x1E
		BMI	loc_A88
		LDR	R5, =0x40042148
		LDRH	R5, [R5]
		UXTH	R5, R5
		ANDS.W	R5, R5,	#0x3F
		MOVS	R1, R5
		CMP	R1, #0
		BNE	loc_A4C
		LDR	R5, =0x40042160
		LDRSH.W	R5, [R5]
		B	loc_A7A
@ ---------------------------------------------------------------------------

loc_A4C:
		LDR	R5, [R0,#4]
		MOVS	R2, R5

loc_A50:
		CMP	R1, #2
		BLT	loc_A60
		LDR	R5, =0x40042160
		LDRH	R5, [R5]
		STRH	R5, [R2]
		ADDS	R2, R2,	#2
		SUBS	R1, R1,	#2
		B	loc_A50
@ ---------------------------------------------------------------------------

loc_A60:
		CMP	R1, #0
		BEQ	loc_A6A
		LDR	R5, =0x40042160
		LDRB	R5, [R5]
		STRB	R5, [R2]

loc_A6A:
		MOVS	R5, #0
		STRH	R5, [R0,#8]
		LDR	R5, =0x40042144
		LDRH	R5, [R5]
		ORRS.W	R5, R5,	#0x4000
		LDR	R6, =0x40042144
		STRH	R5, [R6]

loc_A7A:
		LDR	R5, =0x40042148
		LDRH	R5, [R5]
		MOVW	R6, #0xFBFF
		ANDS	R5, R6
		LDR	R6, =0x40042148
		STRH	R5, [R6]

loc_A88:
		LDRH	R5, [R0,#8]
		CMP	R5, #0
		BEQ	loc_ACA

loc_A8E:
		LDR	R5, =0x40042144
		LDRH	R5, [R5]
		LSLS	R5, R5,	#0x15
		BPL	loc_A8E
		LDR	R5, [R0]
		MOVS	R2, R5
		LDRH	R5, [R0,#8]
		MOVS	R1, R5

loc_A9E:
		CMP	R1, #2
		BLT	loc_AB0
		LDRH	R5, [R2]
		MOVS	R4, R5
		LDR	R5, =0x40042160
		STRH	R4, [R5]
		ADDS	R2, R2,	#2
		SUBS	R1, R1,	#2
		B	loc_A9E
@ ---------------------------------------------------------------------------

loc_AB0:
		CMP	R1, #0
		BEQ	loc_ABA
		LDR	R5, =0x40042160
		LDRB	R6, [R2]
		STRB	R6, [R5]

loc_ABA:
		MOVS	R5, #0
		STRH	R5, [R0,#8]
		LDR	R5, =0x40042144
		LDRH	R5, [R5]
		ORRS.W	R5, R5,	#0x4000
		LDR	R6, =0x40042144
		STRH	R5, [R6]

loc_ACA:
		CMP	R3, #1
		BNE	loc_AF2

loc_ACE:
		LDR	R5, =0x40042144
		LDRH	R5, [R5]
		LSLS	R5, R5,	#0x15
		BPL	loc_ACE
		LDR	R5, =0x40042144
		LDRH	R5, [R5]
		MOVW	R6, #0xFBFF
		ANDS	R5, R6
		LDR	R6, =0x40042144
		STRH	R5, [R6]
		LDR	R5, =0x40042144
		LDRH	R5, [R5]
		MOVW	R6, #0xBFFF
		ANDS	R5, R6
		LDR	R6, =0x40042144
		STRH	R5, [R6]

loc_AF2:
		POP	{R4-R6}
		BX	LR
@ End of function sub_A1C


@ =============== S U B	R O U T	I N E =======================================


sub_AF6:
		PUSH	{R4,R5}
		MOVS	R3, R0
		LDRB.W	R0, [R3,#0x34]
		CMP	R0, #0
		BNE	loc_B06
		MOVS	R0, #0
		B	loc_B3E
@ ---------------------------------------------------------------------------

loc_B06:
		LDRB.W	R0, [R3,#0x21]
		CMP	R0, #2
		BEQ	loc_B12
		MOVS	R0, #0
		B	loc_B3E
@ ---------------------------------------------------------------------------

loc_B12:
		LDR	R0, [R3,#8]
		MOVS	R5, R0
		MOVS	R0, #0
		MOVS	R4, R0

loc_B1A:
		CMP	R4, R2
		BCS	loc_B3A
		LDR	R0, [R3,#0xC]
		CMP	R5, R0
		BEQ	loc_B3A
		LDRB	R0, [R5]
		STRB	R0, [R1]
		ADDS	R5, R5,	#1
		ADDS	R1, R1,	#1
		LDR	R0, [R3,#4]
		CMP	R0, R5
		BCS	loc_B36
		LDR	R0, [R3]
		MOVS	R5, R0

loc_B36:
		ADDS	R4, R4,	#1
		B	loc_B1A
@ ---------------------------------------------------------------------------

loc_B3A:
		STR	R5, [R3,#8]
		MOVS	R0, R4

loc_B3E:
		POP	{R4,R5}
		BX	LR
@ End of function sub_AF6

.pool

@ =============== S U B	R O U T	I N E =======================================


sub_B42:
		PUSH	{R4-R7}
		MOVS	R3, R0
		LDRH	R0, [R3,#0x14]
		CMP	R0, #0
		BEQ	loc_B50
		MOVS	R0, #0
		B	loc_B92
@ ---------------------------------------------------------------------------

loc_B50:
		LDR	R0, [R3,#0x2C]
		LDRH	R0, [R0]
		LSLS	R0, R0,	#0x15
		BMI	loc_B5C
		MOVS	R0, #0
		B	loc_B92
@ ---------------------------------------------------------------------------

loc_B5C:
		MOVS	R7, R2
		LDR	R0, [R3,#0x30]
		MOVS	R6, R0
		LDRH	R0, [R3,#0x1C]
		CMP	R7, R0
		BLT	loc_B6A
		LDRH	R7, [R3,#0x1C]

loc_B6A:
		MOVS	R5, R7
		MOVS	R0, #0
		MOVS	R4, R0

loc_B70:
		CMP	R7, #1
		BLT	loc_B8E
		MOVS	R0, R4
		LSLS	R0, R0,	#0x1F
		BPL	loc_B82
		LDRB	R0, [R1]
		STRB	R0, [R6,#1]
		ADDS	R1, R1,	#1
		B	loc_B88
@ ---------------------------------------------------------------------------

loc_B82:
		LDRB	R0, [R1]
		STRB	R0, [R6]
		ADDS	R1, R1,	#1

loc_B88:
		SUBS	R7, R7,	#1
		ADDS	R4, R4,	#1
		B	loc_B70
@ ---------------------------------------------------------------------------

loc_B8E:
		STRH	R5, [R3,#0x14]
		MOVS	R0, R5

loc_B92:
		POP	{R4-R7}
		BX	LR
@ End of function sub_B42

.pool

loc_BB4:
		BL	sub_BCA
		CMP	R0, #0
		BEQ	loc_BC0
		NOP
		NOP

loc_BC0:
		MOVS	R0, #0
		BL	sub_0
		BL	sub_BCE

@ =============== S U B	R O U T	I N E =======================================


sub_BCA:
		MOVS	R0, #1
		BX	LR
@ End of function sub_BCA


@ =============== S U B	R O U T	I N E =======================================

@ Attributes: noreturn

sub_BCE:
		B.W	loc_BD4
@ ---------------------------------------------------------------------------

loc_BD4:
		MOV	R7, R0

loc_BD6:
		MOV	R0, R7
		BL	loc_BE0
@ ---------------------------------------------------------------------------
		B	loc_BD6
@ End of function sub_BCE

@ ---------------------------------------------------------------------------
@ START	OF FUNCTION CHUNK FOR sub_BCE

loc_BE0:
		LDR	R1, =0x20026
		MOVS	R0, #0x18
		BKPT	0xAB
		B	loc_BE0
@ END OF FUNCTION CHUNK	FOR sub_BCE
@ ---------------------------------------------------------------------------
		NOP
		NOP
		NOP
		NOP
		BL	loc_BB4
@ ---------------------------------------------------------------------------
		LDR	R0, =0x20000001
		BX	R0
@ ---------------------------------------------------------------------------

.pool

loc_C00:
		B.W	loc_C00
@ ---------------------------------------------------------------------------

loc_C04:
		B.W	loc_C04
@ ---------------------------------------------------------------------------

loc_C08:
		B.W	loc_C08
@ ---------------------------------------------------------------------------

loc_C0C:
		B.W	loc_C0C
@ ---------------------------------------------------------------------------

loc_C10:
		B.W	loc_C10
@ ---------------------------------------------------------------------------

loc_C14:
		B.W	loc_C14
@ ---------------------------------------------------------------------------

loc_C18:
		B.W	loc_C18
@ ---------------------------------------------------------------------------

loc_C1C:
		B.W	loc_C1C
@ ---------------------------------------------------------------------------

loc_C20:
		B.W	loc_C20
@ ---------------------------------------------------------------------------

loc_C24:
		B.W	loc_C24
@ ---------------------------------------------------------------------------

loc_C28:
		B.W	loc_C28
@ ---------------------------------------------------------------------------

loc_C2C:
		B.W	loc_C2C
@ ---------------------------------------------------------------------------

loc_C30:
		B.W	loc_C30
@ ---------------------------------------------------------------------------

loc_C34:
		B.W	loc_C34
@ ---------------------------------------------------------------------------

loc_C38:
		B.W	loc_C38
@ ---------------------------------------------------------------------------

loc_C3C:
		B.W	loc_C3C
@ ---------------------------------------------------------------------------

loc_C40:
		B.W	loc_C40
@ ---------------------------------------------------------------------------

loc_C44:
		B.W	loc_C44
@ ---------------------------------------------------------------------------

loc_C48:
		B.W	loc_C48
@ ---------------------------------------------------------------------------

loc_C4C:
		B.W	loc_C4C
@ ---------------------------------------------------------------------------

loc_C50:
		B.W	loc_C50
@ ---------------------------------------------------------------------------

loc_C54:
		B.W	loc_C54
@ ---------------------------------------------------------------------------

loc_C58:
		B.W	loc_C58
@ ---------------------------------------------------------------------------

loc_C5C:
		B.W	loc_C5C
@ ---------------------------------------------------------------------------

loc_C60:
		B.W	loc_C60
@ ---------------------------------------------------------------------------

loc_C64:
		B.W	loc_C64
@ ---------------------------------------------------------------------------

loc_C68:
		B.W	loc_C68
@ ---------------------------------------------------------------------------

loc_C6C:
		B.W	loc_C6C
@ ---------------------------------------------------------------------------

loc_C70:
		B.W	loc_C70
@ ---------------------------------------------------------------------------

loc_C74:
		B.W	loc_C74
@ ---------------------------------------------------------------------------

loc_C78:
		B.W	loc_C78
@ ---------------------------------------------------------------------------

loc_C7C:
		B.W	loc_C7C
@ ---------------------------------------------------------------------------

loc_C80:
		B.W	loc_C80
@ ---------------------------------------------------------------------------

loc_C84:
		B.W	loc_C84
@ ---------------------------------------------------------------------------

loc_C88:
		B.W	loc_C88
@ ---------------------------------------------------------------------------

loc_C8C:
		B.W	loc_C8C
@ ---------------------------------------------------------------------------

loc_C90:
		B.W	loc_C90
@ ---------------------------------------------------------------------------

loc_C94:
		B.W	loc_C94
@ ---------------------------------------------------------------------------

loc_C98:
		B.W	loc_C98
@ ---------------------------------------------------------------------------

loc_C9C:
		B.W	loc_C9C
@ ---------------------------------------------------------------------------

loc_CA0:
		B.W	loc_CA0
@ ---------------------------------------------------------------------------

loc_CA4:
		B.W	loc_CA4
@ ---------------------------------------------------------------------------

loc_CA8:
		B.W	loc_CA8
@ ---------------------------------------------------------------------------

loc_CAC:
		B.W	loc_CAC
@ ---------------------------------------------------------------------------

loc_CB0:
		B.W	loc_CB0
@ ---------------------------------------------------------------------------

loc_CB4:
		B.W	loc_CB4
@ ---------------------------------------------------------------------------

.align 4

baz:		.ascii "MB9B500R Rev1.05"
		.end

		.end
